## scikit-learn 0.18.1

=== debian/changelog ===
scikit-learn (0.18.1-1~nd14.04+1) trusty; urgency=medium

  * Backported for trusty.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 14 Nov 2016 15:33:08 -0500

scikit-learn (0.18.1-1) unstable; urgency=medium

  * Fresh bugfix (strongly advised to upgrade) release
  * debian/patches
    - many patches updated

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 13 Nov 2016 18:52:53 -0500

=== debian/control ===
Source: scikit-learn
Section: python
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50), dh-autoreconf,
               python-all-dev (>= 2.6.6-3~), dh-python,
               cython (>= 0.12~),
               python-setuptools,
               python-numpy, python-scipy,
               python-nose,
               python-matplotlib,
               python-joblib (>= 0.9.2),
               python3-all-dev,
               cython3,
               python3-setuptools,
               python3-numpy, python3-scipy,
               python3-nose,
               python3-matplotlib,
               python3-joblib (>= 0.9.2),
               libsvm-dev (>= 2.84.0),
               libatlas3-base,
Build-Depends-Indep:
               python-sphinx (>= 1.0), python-imaging, graphviz,
Standards-Version: 3.9.6
X-Python-Version: >= 2.6
Homepage: http://scikit-learn.sourceforge.net
Vcs-Browser: http://github.com/yarikoptic/scikit-learn
Vcs-Git: git://github.com/yarikoptic/scikit-learn.git -b debian

Package: python-sklearn
Replaces: python-scikits-learn (<< 0.9~)
Breaks: python-scikits-learn (<< 0.9~)
Architecture: all
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
         python-joblib (>= 0.9.2),
Provides: ${python:Provides}
Recommends: python-nose, python-matplotlib
Suggests: python-dap, python-scikits-optimization, python-sklearn-doc, ipython
Enhances: python-mvpa2, python-mdp
Description: Python modules for machine learning and data mining
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)

Package: python-sklearn-lib
Conflicts: python-scikits-learn-lib
Replaces: python-scikits-learn-lib
Architecture: any
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
Description: low-level implementations and bindings for scikit-learn
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.

Package: python3-sklearn
Architecture: all
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
         python3-joblib (>= 0.9.2),
Provides: ${python:Provides}
Recommends: python3-nose, python3-matplotlib
Suggests: python3-dap, python-sklearn-doc, ipython3
Enhances: python3-mvpa2, python3-mdp
Description: Python modules for machine learning and data mining
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)
 .
 This package contains the Python 3 version.

Package: python3-sklearn-lib
Architecture: any
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python:Provides}
Description: low-level implementations and bindings for scikit-learn - Python 3
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.
 .
 This package contains the Python 3 version.


Package: python-sklearn-doc
Conflicts: python-scikits-learn-doc
Replaces: python-scikits-learn-doc
Architecture: all
Section: doc
Depends: neurodebian-popularity-contest, ${misc:Depends}, libjs-jquery, libjs-underscore
Suggests: python-sklearn
Description: documentation and examples for scikit-learn
 This package contains documentation and example scripts for
 python-sklearn.

Package: python-scikits-learn
Depends: neurodebian-popularity-contest, python-sklearn, ${misc:Depends}, ${python:Depends}
Architecture: all
Section: oldlibs
Description: transitional compatibility package for scikits.learn -> sklearn migration
 Provides old namespace (scikits.learn) and could be removed if
 dependent code migrated to use sklearn for clarity of the namespace.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

PACKAGE2_NAME = python-sklearn
PACKAGE3_NAME = python3-sklearn
PACKAGE2_ROOT_DIR = debian/${PACKAGE2_NAME}
PACKAGE3_ROOT_DIR = debian/${PACKAGE3_NAME}

PYVERS = $(shell pyversions -vr)
PYVER = $(shell pyversions  -vd)
PY3VERS = $(shell py3versions -vr)
PY3VER = $(shell py3versions -vd)

SPHINX_VER := $(shell python -c 'from sphinx import __version__; print __version__')
NODOC = $(shell dpkg --compare-versions $(SPHINX_VER) lt 1.1.3 && echo "nodoc" || echo "")
export DEB_BUILD_OPTIONS += $(NODOC)

MIN_CYTHONVER = 0.23

CYTHON_VER := $(shell dpkg -l cython 2>/dev/null | awk '/^ii/{print $$3;}' || echo 0)
RECONF = $(shell dpkg --compare-versions $(CYTHON_VER) ge $(MIN_CYTHONVER) && echo ",autoreconf" || echo "")

# Some tests are known to fail randomly so need to be excluded ATM
# A bit aggressive exclusion of some tests which exhibit a problem I have no time to deal with on arm64
NOSEARGS := $(shell dpkg --print-architecture | grep -q -v arm64 || echo --exclude='test_dump')
# https://github.com/scikit-learn/scikit-learn/issues/7544
NOSEARGS += $(shell dpkg --print-architecture | grep -q -v i386 || echo --exclude='test_gpr')
# https://github.com/scikit-learn/scikit-learn/issues/7572
NOSEARGS += $(shell dpkg --print-architecture | grep -q -v armel || echo --exclude='test_matthews_corrcoef')
# --exclude='test_(sparse_svc_clone_with_callable_kernel|spectral_clustering_sparse|ovr_fit_predict)'
# https://buildd.debian.org/status/fetch.php?pkg=scikit-learn&arch=ppc64el&ver=0.18-3&stamp=1475603905
NOSEARGS += $(shell dpkg --print-architecture | grep -q -v ppc64el || echo --exclude='test_non_meta_estimators')


# try to prevent unsunctioned downloads
export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

# Mega rule
%:
	: # Explicit build system to avoid use of all-in-1 Makefile
	dh $@ --buildsystem=python_distutils --with python2,python3$(RECONF)

clean_generated:
	find sklearn/ -regex '.*\.c\(\|pp\)' | xargs grep -l -e 'Generated by Cython'  | xargs -r rm -f

_cythonize%: clean_generated
	debian/rules clean_generated # force removal of previous copies
	python$(*:2=) setup.py build_src
	D=debian/cythonized-files$(*:2=) && \
		git rm -rf $$D; \
		find sklearn/ -regex '.*\.c\(\|pp\)' | while read f; do \
			grep -q 'Generated by Cython' "$$f" || continue; \
			mkdir -p "$$D/$$(dirname $$f)"; \
			cp "$$f" "$$D/$$(dirname $$f)"; \
			git add -f "$$D/$$f"; \
		done; \
		echo "$(UVER)" >| $$D/VERSION; git add $$D/VERSION

_uncythonize%:
	echo "$*" | grep -q '^3' && PY=3 || PY= ; \
	CYTHONVER=$$(dpkg -l cython$$PY 2>/dev/null | awk '/^ii/{print $$3;}' || echo 0); \
	dpkg --compare-versions "$$CYTHONVER" lt "$(MIN_CYTHONVER)" && { \
		echo "I: Using pre-Cython-ed files for Python $*"; \
		touch PKG-INFO; \
		cd debian/cythonized-files$$PY/ ; \
		find . -regex '.*\.c\(\|pp\)' | while read f; do cp $$f ../../$$f; done; } || :

cythonize: _cythonize2 _cythonize3

override_dh_auto_configure: _uncythonize2 _uncythonize3
	dh_auto_configure

override_dh_autoreconf:
	dh_autoreconf debian/rules -- clean_generated

override_dh_clean:
	rm -rf build doc/_build doc/auto_examples *-stamp *.egg-info sklearn/datasets/__config__.py
	dh_clean

override_dh_auto_install: ${PYVERS:%=python-install%} ${PY3VERS:%=python-install%} ${PYVERS:%=python-test%} ${PY3VERS:%=python-test%}
# Per Python version logic -- install, test, move .so into -lib
python-install%: _uncythonize%
	python$* setup.py install --install-layout=deb  --root=$(CURDIR)/debian/tmp

python-test%: python-install%
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	: # Run unittests here against installed scikits.learn
	echo "$*" | grep -q '^3' && PY=3 || PY=$*; \
	export PYTHONPATH=`/bin/ls -d $$PWD/debian/tmp/usr/lib/python$$PY/*/`; \
	export MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
	export JOBLIB_MULTIPROCESSING=2; \
	cd build/; python$* /usr/bin/nosetests -s -v $(NOSEARGS) sklearn && \
	  { python$* /usr/bin/nosetests -v --with-doctest --doctest-extension=rst ../doc/ || : ; } # doctests are failing ATM
else
	: # Skip unittests due to nocheck
endif


override_dh_installdocs:
	: # Build Documentation using installed scikits.learn
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
	: # not building documentation in -a
else
	export PYTHONPATH=`/bin/ls -d $$PWD/debian/tmp/usr/lib/python$(PYVER)/*`; \
	export MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
	 cd doc; $(MAKE) html
endif
else
	mkdir -p doc/_build/html
	echo "<HTML><BODY><P>sklearn documentation was not built.<P>Please visit <A HREF='http://scikit-learn.org'>http://scikit-learn.org</A></BODY></HTML>" >| doc/_build/html/index.html
endif
	: # Use jquery from Debian package, so prune shipped one
	-rm doc/_build/html/stable/_static/jquery.js
	-rm doc/_build/html/stable/_static/underscore.js
	dh_installdocs -A AUTHORS.rst README*.rst

override_dh_installchangelogs:
	dh_installchangelogs doc/whats_new.rst

## remove .so libraries from main package, and call dh_numpy*
## while removing 2 if not present
_dh_python%:
	[ ! -e debian/python$(*:2=)-sklearn ] \
	    || find debian/python$(*:2=)-sklearn/usr/lib -name "*.so" -delete;
	[ -e /usr/bin/dh_numpy$(*:2=) ] && dh_numpy$(*:2=) -ppython$(*:2=)-sklearn-lib || :
	: # Prune scikits/__init__.py to avoid conflicts
	find debian -wholename \*scikits/__init__.py -delete
	: # Move scikits. space into a compatibility package
	if [ $* -eq 2 ]; then \
	set -e; \
	find debian -wholename \*scikits -type d | while read skd; do \
		skbd=$$(dirname $$skd); \
		skbd_=$$(echo $$skbd | sed -e 's/sklearn/scikits-learn/g'); \
		mkdir -p $$skbd_; \
		mv $$skd $$skbd_; \
	done; \
	fi
	dh_python$*

## "Instantiate" both rules so dh sees them
override_dh_python2: _dh_python2
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv


## to prepare next Debian upstream source tarball
dfsg: dfsg-releases
dfsg-%:
	git checkout dfsg
	-git merge --no-commit $*
	-git rm -rf sklearn/externals/joblib
	: # -git rm -f ./sklearn/svm/src/libsvm/svm.*
	git commit -m "Merge $* into DFSG (pruning externals: joblib)" -a
	git checkout debian

## scikit-learn 0.19.0

=== debian/changelog ===
scikit-learn (0.19.0-1) unstable; urgency=medium

  * Fresh upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 11 Aug 2017 18:12:48 -0400

scikit-learn (0.19~b2-1) experimental; urgency=medium

  * Upcoming release beta
    - some deprecations in API
  * d/
    - boost compat to 9
    - boost policy to 3.9.8 (for now)
  * d/control
    - added pytest to b-depends and recommends
  * d/rules
    - for cython < 0.24 use pre-cythonized sources (to avoid FTBFS on 16.04)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 18 Jul 2017 15:35:44 -0400

=== debian/control ===
Source: scikit-learn
Section: python
Priority: optional
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9), dh-autoreconf,
               python-all-dev (>= 2.6.6-3~), dh-python,
               cython (>= 0.12~),
               python-setuptools,
               python-numpy (>= 1:1.8.2~), python-scipy,
               python-nose,
               python-pytest,
               python-matplotlib,
               python-joblib (>= 0.9.2),
               python3-all-dev,
               cython3,
               python3-setuptools,
               python3-numpy, python3-scipy,
               python3-nose,
               python3-pytest,
               python3-matplotlib,
               python3-joblib (>= 0.9.2),
               libsvm-dev (>= 2.84.0),
               libatlas3-base,
Build-Depends-Indep:
               python-sphinx (>= 1.0), python-imaging, graphviz,
Standards-Version: 3.9.8
X-Python-Version: >= 2.6
Homepage: http://scikit-learn.sourceforge.net
Vcs-Browser: http://github.com/yarikoptic/scikit-learn
Vcs-Git: git://github.com/yarikoptic/scikit-learn.git -b debian

Package: python-sklearn
Replaces: python-scikits-learn (<< 0.9~)
Breaks: python-scikits-learn (<< 0.9~)
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
         python-joblib (>= 0.9.2),
Provides: ${python:Provides}
Recommends: python-nose, python-pytest, python-matplotlib
Suggests: python-dap, python-scikits-optimization, python-sklearn-doc, ipython
Enhances: python-mvpa2, python-mdp
Description: Python modules for machine learning and data mining
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)

Package: python-sklearn-lib
Conflicts: python-scikits-learn-lib
Replaces: python-scikits-learn-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
Description: low-level implementations and bindings for scikit-learn
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.

Package: python3-sklearn
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
         python3-joblib (>= 0.9.2),
Provides: ${python:Provides}
Recommends: python3-nose, python-pytest, python3-matplotlib
Suggests: python3-dap, python-sklearn-doc, ipython3
Enhances: python3-mvpa2, python3-mdp
Description: Python modules for machine learning and data mining
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)
 .
 This package contains the Python 3 version.

Package: python3-sklearn-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python:Provides}
Description: low-level implementations and bindings for scikit-learn - Python 3
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.
 .
 This package contains the Python 3 version.


Package: python-sklearn-doc
Conflicts: python-scikits-learn-doc
Replaces: python-scikits-learn-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
Suggests: python-sklearn
Description: documentation and examples for scikit-learn
 This package contains documentation and example scripts for
 python-sklearn.

Package: python-scikits-learn
Depends: python-sklearn, ${misc:Depends}, ${python:Depends}
Architecture: all
Section: oldlibs
Description: transitional compatibility package for scikits.learn -> sklearn migration
 Provides old namespace (scikits.learn) and could be removed if
 dependent code migrated to use sklearn for clarity of the namespace.

## scikit-learn 0.19.1

=== Makefile ===
# simple makefile to simplify repetitive build env management tasks under posix

# caution: testing won't work on windows, see README

PYTHON ?= python
CYTHON ?= cython
NOSETESTS ?= nosetests
CTAGS ?= ctags

# skip doctests on 32bit python
BITS := $(shell python -c 'import struct; print(8 * struct.calcsize("P"))')

ifeq ($(BITS),32)
  NOSETESTS:=$(NOSETESTS) -c setup32.cfg
endif


all: clean inplace test

clean-ctags:
	rm -f tags

clean: clean-ctags
	$(PYTHON) setup.py clean
	rm -rf dist

in: inplace # just a shortcut
inplace:
	$(PYTHON) setup.py build_ext -i

test-code: in
	$(NOSETESTS) -s -v sklearn
test-sphinxext:
	$(NOSETESTS) -s -v doc/sphinxext/
test-doc:
ifeq ($(BITS),64)
	$(NOSETESTS) -s -v doc/*.rst doc/modules/ doc/datasets/ \
	doc/developers doc/tutorial/basic doc/tutorial/statistical_inference \
	doc/tutorial/text_analytics
endif

test-coverage:
	rm -rf coverage .coverage
	$(NOSETESTS) -s -v --with-coverage sklearn

test: test-code test-sphinxext test-doc

trailing-spaces:
	find sklearn -name "*.py" -exec perl -pi -e 's/[ \t]*$$//' {} \;

cython:
	python setup.py build_src

ctags:
	# make tags for symbol based navigation in emacs and vim
	# Install with: sudo apt-get install exuberant-ctags
	$(CTAGS) --python-kinds=-i -R sklearn

doc: inplace
	$(MAKE) -C doc html

doc-noplot: inplace
	$(MAKE) -C doc html-noplot

code-analysis:
	flake8 sklearn | grep -v __init__ | grep -v external
	pylint -E -i y sklearn/ -d E1103,E0611,E1101

flake8-diff:
	./build_tools/travis/flake8_diff.sh

=== build_tools/appveyor/requirements.txt ===
# Fetch numpy and scipy wheels from the sklearn rackspace wheelhouse.
# Those wheels were collected from http://www.lfd.uci.edu/~gohlke/pythonlibs/
# This is a temporary solution. As soon as numpy and scipy provide official
# wheel for windows we ca delete this --find-links line.
--find-links http://28daf2247a33ed269873-7b1aad3fab3cc330e1fd9d109892382a.r6.cf2.rackcdn.com/

# fix the versions of numpy to force the use of numpy and scipy to use the whl
# of the rackspace folder instead of trying to install from more recent
# source tarball published on PyPI
numpy==1.9.3
scipy==0.16.0
cython
nose
nose-timer
wheel
wheelhouse_uploader

=== debian/changelog ===
scikit-learn (0.19.1-4build1) cosmic; urgency=medium

  * No-change rebuild to build for python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jun 2018 12:37:17 +0000

scikit-learn (0.19.1-4) unstable; urgency=medium

  * debian/control
    - build-depends on python-pil not deprecating -imaging (Closes: #894526)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 08 Apr 2018 10:02:12 -0400

scikit-learn (0.19.1-3) unstable; urgency=medium

  * debian/patches/changeset_6c99d797d7c71d216503612a242bffb8d006582d.diff
    to avoid regression due to forgotten in the release fix
    (see https://github.com/scikit-learn/scikit-learn/issues/9393)
    It seems that the issue is not deterministic, and although did not
    reveal itself on a buildd server, might come back.

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 04 Jan 2018 08:02:20 -0500

scikit-learn (0.19.1-2) unstable; urgency=medium

  * debian/patches/deb_precisionloss
    - to mitigate a minor failing unittest on BE platforms
      (Closes: #883473)
  * debian/control
    - boosted policy to 4.1.2 (if something to be done, report a bug)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 04 Dec 2017 22:42:37 -0500

scikit-learn (0.19.1-1) unstable; urgency=medium

  * Fresh upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 23 Oct 2017 15:59:32 -0400

=== debian/control ===
--- 
+++ 
@@ -23,8 +23,8 @@
                libsvm-dev (>= 2.84.0),
                libatlas3-base,
 Build-Depends-Indep:
-               python-sphinx (>= 1.0), python-imaging, graphviz,
-Standards-Version: 3.9.8
+               python-sphinx (>= 1.0), python-pil, graphviz,
+Standards-Version: 4.1.2
 X-Python-Version: >= 2.6
 Homepage: http://scikit-learn.sourceforge.net
 Vcs-Browser: http://github.com/yarikoptic/scikit-learn

## scikit-learn 0.19.2

=== build_tools/appveyor/requirements.txt ===
--- 
+++ 
@@ -7,9 +7,9 @@
 # fix the versions of numpy to force the use of numpy and scipy to use the whl
 # of the rackspace folder instead of trying to install from more recent
 # source tarball published on PyPI
-numpy==1.9.3
-scipy==0.16.0
-cython
+numpy==1.14.5
+scipy==1.1.0
+cython==0.27.3
 nose
 nose-timer
 wheel

=== debian/changelog ===
scikit-learn (0.19.2-1) unstable; urgency=medium

  * Fresh upstream bugfix release (Closes: #904636)
    - supports Python 3.7
  * debian/control
    - removed transitional python-scikits-learn (Closes: #878863)

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 26 Jul 2018 10:12:10 -0400

=== debian/control ===
--- 
+++ 
@@ -101,11 +101,3 @@
 Description: documentation and examples for scikit-learn
  This package contains documentation and example scripts for
  python-sklearn.
-
-Package: python-scikits-learn
-Depends: python-sklearn, ${misc:Depends}, ${python:Depends}
-Architecture: all
-Section: oldlibs
-Description: transitional compatibility package for scikits.learn -> sklearn migration
- Provides old namespace (scikits.learn) and could be removed if
- dependent code migrated to use sklearn for clarity of the namespace.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 NODOC = $(shell dpkg --compare-versions $(SPHINX_VER) lt 1.1.3 && echo "nodoc" || echo "")
 export DEB_BUILD_OPTIONS += $(NODOC)
 
-MIN_CYTHONVER = 0.23
+MIN_CYTHONVER = 0.24
 
 CYTHON_VER := $(shell dpkg -l cython 2>/dev/null | awk '/^ii/{print $$3;}' || echo 0)
 RECONF = $(shell dpkg --compare-versions $(CYTHON_VER) ge $(MIN_CYTHONVER) && echo ",autoreconf" || echo "")

## scikit-learn 0.20.0+dfsg

=== debian/changelog ===
scikit-learn (0.20.0+dfsg-2~nd18.04+1) bionic; urgency=medium

  * Backported for bionic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 08 Nov 2018 11:02:32 -0500

scikit-learn (0.20.0+dfsg-2) unstable; urgency=medium

  [ Yaroslav Halchenko ]
  * dump debhelper compat to 9 to ease backportability. Added a note to
    debian/README.source
    - with that it correctly places numerous examples within -doc package
      instead of a selected pure python- one
  * debian/rules
    - removed running doctests on python3 as well -- output fluctuates across
      platforms and releases
    - skip tests marked "network" (requiring download of some test datasets)
    - invoke show_versions() for all pythons before running tests
  * debian/patches
    + Skip some tests if joblib is forced into serial mode
      (from https://github.com/scikit-learn/scikit-learn/pull/12496)
      0001-BF-skip-test_backend_respected-if-joblib-is-forced-i.patch
      0002-BF-TST-skip-test_lr_liblinear_warning-in-joblib-seri.patch

  [ Mo Zhou <cdluminate@gmail.com>]
  * debian/rules
    - skip some tests which show problems on some architectures

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 07 Nov 2018 21:29:46 -0500

scikit-learn (0.20.0+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille <tille@debian.org> ]
  * New upstream release
    Closes: #907806
  * Move to Debian Science team maintenance
  * Maintained at salsa.debian.org
  * d/watch:
     - Point to pypi since releases are not tagged reliably at Github
     - Use repacksuffix=+dfsg, compression=xz
     - Inject '~' between version number and rc to sort real release highter
  * d/control: Use Files-Excluded to remove files from upstream source
  * d/gbp.conf: Strip default and unusual options

  [ Yangfl <mmyangfl@gmail.com> ]
  * Introduce dh_sphinxdoc (Closes: #859149)
  * Refresh d/copyright
  * Add autopkgtests
  * d/compat
    - bump debhelper compat to 11
  * d/control
    - remove deprecated X-Python*-Version fields
    - remove build dep dh-autoreconf and cython
    - add build dep dh-python
    - add build dep librsvg2-bin, python3-sphinx-gallery, python3-numpydoc,
      python3-pandas and python3-skimage, required by doc building
    - add build dep python3-doc, python-numpy-doc, python-scipy-doc and
      python-matplotlib-doc for intersphinx mappings
    - add dep libjs-{bootstrap,mathjax} for python-sklearn-doc
    - fix Recommends python3-pytest of python3-sklearn
    - switch to Python 3 doc build dep
    - bump standard to 4.2.1
  * d/patches
    - add disable-doctest.patch to prevent Python 2 doctest failure
    - add no-buttons-js.patch
    - add no-download-intersphinx-mapping.patch
    - add parallel-cythonize.patch
    - update deb_use_system_joblib to fix test failure
    - update deb_no_online_jquery
    - remove deb_optional_linkcode
  * d/rules
    - switch from python_distutils to pybuild
    - rewrite

  [ Mo Zhou <cdluminate@gmail.com> ]
  * Fixup autopkgtest for python3.

 -- Yangfl <mmyangfl@gmail.com>  Mon, 22 Oct 2018 13:34:15 +0000

=== debian/control ===
Source: scikit-learn
Section: python
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9~),
               dh-python,
               python-all-dev (>= 2.6.6-3~),
               python-setuptools,
               python-numpy (>= 1:1.8.2~), python-scipy,
               python-nose, python-pytest,
               python-matplotlib,
               python-joblib (>= 0.9.2),
               python3-all-dev,
               cython3,
               python3-setuptools,
               python3-numpy, python3-scipy,
               python3-nose, python3-pytest,
               python3-matplotlib,
               python3-joblib (>= 0.9.2),
               libsvm-dev (>= 2.84.0),
               libblas-dev | libblas.so,
               libatlas-base-dev,
               python-pandas <!nocheck>, python3-pandas <!nocheck>,
               python-pil <!nocheck>, python3-pil <!nocheck>,
Build-Depends-Indep: python3-sphinx (>= 1.0),
                     python3-sphinx-gallery,
                     python3-numpydoc,
                     python3-pandas,
                     python3-skimage,
                     python3-pil,
                     librsvg2-bin,
                     graphviz,
                     python3-doc,
                     python-numpy-doc,
                     python-scipy-doc,
                     python-matplotlib-doc,
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/scikit-learn
Vcs-Git: https://salsa.debian.org/science-team/scikit-learn.git
Homepage: http://scikit-learn.sourceforge.net

Package: python-sklearn
Replaces: python-scikits-learn (<< 0.9~)
Breaks: python-scikits-learn (<< 0.9~)
Architecture: all
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
         python-joblib (>= 0.9.2),
Provides: ${python:Provides}
Recommends: python-nose, python-pytest, python-matplotlib
Suggests: python-dap, python-scikits-optimization, python-sklearn-doc, ipython
Enhances: python-mvpa2, python-mdp
Description: Python modules for machine learning and data mining
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)

Package: python-sklearn-lib
Conflicts: python-scikits-learn-lib
Replaces: python-scikits-learn-lib
Architecture: any
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
Description: low-level implementations and bindings for scikit-learn
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.

Package: python3-sklearn
Architecture: all
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
         python3-joblib (>= 0.9.2),
Recommends: python3-nose, python3-pytest, python3-matplotlib
Suggests: python3-dap, python-sklearn-doc, ipython3
Enhances: python3-mvpa2, python3-mdp
Provides: ${python3:Provides}
Description: Python modules for machine learning and data mining
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)
 .
 This package contains the Python 3 version.

Package: python3-sklearn-lib
Architecture: any
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python3:Provides}
Description: low-level implementations and bindings for scikit-learn - Python 3
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.
 .
 This package contains the Python 3 version.


Package: python-sklearn-doc
Conflicts: python-scikits-learn-doc
Replaces: python-scikits-learn-doc
Architecture: all
Section: doc
Depends: neurodebian-popularity-contest, ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-bootstrap,
         libjs-mathjax,
Built-Using: ${sphinxdoc:Built-Using},
Suggests: python-sklearn
Description: documentation and examples for scikit-learn
 This package contains documentation and example scripts for
 python-sklearn.

## scikit-learn 0.20.1+dfsg

=== debian/changelog ===
scikit-learn (0.20.1+dfsg-1) unstable; urgency=medium

  * New upstream bugfix
  * debian/patches
    - dropping all 00* which were cherrypicked or upstream, and refreshing
      the rest
  * cd to .pybuild to run show_versions()

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 28 Nov 2018 20:44:02 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: scikit-learn
 Section: python
 Priority: optional
-Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
-X-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
 Build-Depends: debhelper (>= 9~),
                dh-python,
@@ -45,7 +44,7 @@
 Replaces: python-scikits-learn (<< 0.9~)
 Breaks: python-scikits-learn (<< 0.9~)
 Architecture: all
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
+Depends: ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
          python-joblib (>= 0.9.2),
 Provides: ${python:Provides}
 Recommends: python-nose, python-pytest, python-matplotlib
@@ -64,7 +63,7 @@
 Conflicts: python-scikits-learn-lib
 Replaces: python-scikits-learn-lib
 Architecture: any
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
 Provides: ${python:Provides}
 Description: low-level implementations and bindings for scikit-learn
  This is an add-on package for python-sklearn. It provides
@@ -73,7 +72,7 @@
 
 Package: python3-sklearn
 Architecture: all
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
+Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
          python3-joblib (>= 0.9.2),
 Recommends: python3-nose, python3-pytest, python3-matplotlib
 Suggests: python3-dap, python-sklearn-doc, ipython3
@@ -92,7 +91,7 @@
 
 Package: python3-sklearn-lib
 Architecture: any
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
 Provides: ${python3:Provides}
 Description: low-level implementations and bindings for scikit-learn - Python 3
  This is an add-on package for python-sklearn. It provides
@@ -107,7 +106,7 @@
 Replaces: python-scikits-learn-doc
 Architecture: all
 Section: doc
-Depends: neurodebian-popularity-contest, ${misc:Depends},
+Depends: ${misc:Depends},
          ${sphinxdoc:Depends},
          libjs-bootstrap,
          libjs-mathjax,

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

# See also: skimage

PY2VERS ?= $(shell pyversions -vr)
PY3VER  ?= $(shell py3versions -vd)
PY3VERS ?= $(shell py3versions -vr)

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

export DEB_CFLAGS_MAINT_APPEND :=
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
  JOBS := 1
endif
export JOBS := $(JOBS)

include /usr/share/dpkg/architecture.mk

PYBUILD_TEST_ARGS = -m "not network"
PYTEST_KEYWORD =

# Some tests are known to fail randomly so need to be excluded ATM
ifeq ($(DEB_HOST_ARCH),arm64)
  # A bit aggressive exclusion of some tests which exhibit a problem I have no time to deal with on arm64
  PYBUILD_TEST_ARGS += -k-test_dump
endif
ifeq ($(DEB_HOST_ARCH),i386)
  # https://github.com/scikit-learn/scikit-learn/issues/7544
  # Closing as outdated -- let's see
  # PYBUILD_TEST_ARGS += -k-test_gpr
endif
ifeq ($(DEB_HOST_ARCH),ppc64el)
  # https://buildd.debian.org/status/fetch.php?pkg=scikit-learn&arch=ppc64el&ver=0.18-3&stamp=1475603905

  PYTEST_KEYWORD += and not test_show_versions_with_blas
  # https://github.com/scikit-learn/scikit-learn/issues/10561
  PYTEST_KEYWORD += and not test_estimate_bandwidth_1sample
  # https://github.com/scikit-learn/scikit-learn/issues/12448
  PYTEST_KEYWORD += and not test_logistic_regression_multi_class_auto
endif

# TODO: figure out WTF
PYTEST_KEYWORD += not test_show_versions_with_blas
PYBUILD_TEST_ARGS += -k "$(PYTEST_KEYWORD)"


export PYBUILD_TEST_PYTEST := 1
# python2 soon deprecated -- doctests unreliable
export PYBUILD_TEST_ARGS_python2 := $(PYBUILD_TEST_ARGS)
export PYBUILD_TEST_ARGS_python3 := $(PYBUILD_TEST_ARGS)
export JOBLIB_MULTIPROCESSING := $(shell expr $(JOBS) / $$(expr $(words $(PY2VERS)) + $(words $(PY3VERS))))

# try to prevent unsunctioned downloads
export http_proxy := http://127.0.0.1:9/
export https_proxy := http://127.0.0.1:9/


%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem pybuild

%-arch:
	dh $@ --with python2,python3 --buildsystem pybuild

clean:
	dh $@ --with python2,python3 --buildsystem pybuild

# silly distutils does not support parallelism! waste hours of time
.PHONY: build
build build-arch build-indep:
	$(MAKE) -j $(JOBS) -f debian/rules _$@

_build-arch: $(addprefix debian/build-stamp-python,$(PY2VERS)) $(addprefix debian/build-stamp-python,$(PY3VERS))
	:
_build _build-indep: _build-arch doc/_build/html
	:

debian/build-stamp-python%: debian/build-stamp-pyx
	PYBUILD_INTERPRETERS=python{version} PYBUILD_VERSIONS=$* dh build-arch --with python$(basename $*) --buildsystem pybuild
	touch $@

override_dh_clean:
	dh_clean
	rm -rf .pytest_cache build scikit_learn.egg-info
	-mv PKG-INFO-BAK PKG-INFO
	rm -f debian/build-stamp-*
	for i in $$(find -name '*.pyx'); do \
		rm -f $${i%.*}.c $${i%.*}.cpp; \
	done
	for i in $$(find -name '*.pyx.in'); do \
		rm -f $${i%.*}; \
	done
ifeq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	+$(MAKE) -C doc clean
endif
endif

debian/build-stamp-pyx:
	-mv PKG-INFO PKG-INFO-BAK
	python$(PY3VER) setup.py config
	mv PKG-INFO-BAK PKG-INFO
	touch $@

doc/_build/html: debian/build-stamp-python$(PY3VER)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# urllib.error.URLError -- have to ignore
	# hotfix SPHINXOPTS -- remove in next release
	-+\
		PYTHONPATH=`/bin/ls -d $(CURDIR)/.pybuild/*python*_$(PY3VER)/build`:$$(python3 -c 'import sys;print(":".join(sys.path))') \
		SPHINXBUILD="python$(PY3VER) -m sphinx -j $(JOBS) -D mathjax_path=MathJax.js" \
		SPHINXOPTS="-j $(JOBS) -D mathjax_path=MathJax.js" \
		$(MAKE) -C doc html
	[ -d $@ ]
endif

# Test data not copied to .pybuild -- manually link for them
override_dh_auto_test-arch:
	for ver in $(PYBUILD_VERSIONS); do \
		i=`/bin/ls -d $(CURDIR)/.pybuild/*python*_$$ver/build/sklearn`; \
        ( cd .pybuild; PYTHONPATH=$$(dirname $$i) python$$ver -c 'import sklearn; sklearn.show_versions()'; ); \
		for dir in data descr images; do \
			rm -rf $$i/datasets/$$dir || true; \
			ln -s ../../../../../sklearn/datasets/$$dir $$i/datasets; \
		done; \
		rm -rf $$i/datasets/tests/data || true; \
		ln -s ../../../../../../sklearn/datasets/tests/data $$i/datasets/tests; \
	done
	dh_auto_test

override_dh_auto_install:
	dh_auto_install
	# cleanup python3 cache (mixing python3 subversions)
	-find debian/tmp -name "__pycache__" -exec rm -r {} +

override_dh_installdocs-arch:
	dh_installdocs -A README*.rst

override_dh_installdocs-indep:
	dh_installdocs -A README*.rst
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
    docdir=debian/python-sklearn-doc/usr/share/doc/python-sklearn-doc; \
	if [ -e $$docdir/stable ] ; then \
	mv \
		$$docdir/stable $$docdir/html; \
    fi
endif

override_dh_installchangelogs:
	dh_installchangelogs doc/whats_new.rst

# remove .so libraries from main package, and call dh_numpy*
_dh_python%:
	-find debian/python$(*:2=)-sklearn/usr/lib -name "*.so" -delete;

	dh_numpy$(*:2=) -ppython$(*:2=)-sklearn-lib
	dh_python$*

override_dh_python2: _dh_python2
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc

override_dh_sphinxdoc-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_sphinxdoc -XMathJax.js -Xjquery.js
endif


## to prepare next Debian upstream source tarball
dfsg: dfsg-releases
dfsg-%:
	git checkout dfsg
	-git merge --no-commit $*
	-git rm -rf sklearn/externals/joblib
	: # -git rm -f ./sklearn/svm/src/libsvm/svm.*
	git commit -m "Merge $* into DFSG (pruning externals: joblib)" -a
	git checkout debian

## scikit-learn 0.20.2%2Bdfsg

=== debian/tests/control ===
Tests: python2
Depends: python-all, python-nose, python-sklearn, python-setuptools, python-numpy (>= 1:1.8.2~), python-scipy, python-nose, python-pytest, python-matplotlib, python-joblib (>= 0.9.2)
Restrictions: allow-stderr

Tests: python3
Depends: python3-all, python3-nose, python3-sklearn, python3-numpy, python3-scipy, python3-nose, python3-pytest, python3-matplotlib, python3-joblib (>= 0.9.2),
Restrictions: allow-stderr
